# **********************************************************************
#
#                     ScopeClock-Simulation
#                     =====================
#                       Uwe Berger; 2012
#
#
# ---------
# Have fun!
#
#***********************************************************************

# Geometrie
set gvar(count_x) 127
set gvar(count_y) $gvar(count_x)
set gvar(dx) [expr 3*$gvar(count_x)]
set gvar(dy) $gvar(dx)
set gvar(r) [expr $gvar(count_x)/2]

# Farben
set gvar(color_off)	darkgreen
set gvar(color_on)	green

# Sinusreihe --> sin(x*2*pi/60)*1000 mit x=0...15
set val_sin {0 105 208 309 407 500 588 669 743 809 866 914 951 978 995 1000}

#Cosinusreihe --> cos(x*2*pi/60)*1000 mit x=0...15
set val_cos {1000 995 978 951 914 866 809 743 669 588 500 407 309 208 105 0}

# Digit-Definitionen
set digit 	[list\
				{{0 5 0 1 1 0 2 0 3 1 3 5 2 6 1 6 0 5 3 1}}\
				{{0 2 2 0 2 6}}\
				{{0 1 1 0 2 0 3 1 3 2 0 6 3 6}}\
				{{0 1 1 0 2 0 3 1 3 2 2 3 3 4 3 5 2 6 1 6 0 5}}\
				{{3 3 0 3 2 0 2 6}}\
				{{3 0 0 0 0 3 2 3 3 4 3 5 2 6 1 6 0 5}}\
				{{3 1 2 0 1 0 0 1 0 5 1 6 2 6 3 5 3 4 2 3 1 3 0 4}}\
				{{0 0 3 0 3 1 0 6}}\
				{{1 3 0 2 0 1 1 0 2 0 3 1 3 2 2 3 1 3 0 4 0 5 1 6 2 6 3 5 3 4 2 3}}\
				{{0 5 1 6 2 6 3 5 3 1 2 0 1 0 0 1 0 2 1 3 2 3 3 2}}\
				{{1 6 1 6}}\
				{{1 4 1 4} {1 2 1 2}}
			]

# Groesse Zeichen bei Zoom-Faktor 1
set gvar(ddx) 3
set gvar(ddy) 6

# Zeichen-Zwischenraum
set gvar(sdx) 3
set gvar(sdy) 10

# Zoom-Faktor Zeichen
set gvar(zoom) 3

# Ziffernblatt mit/ohne Zahlen
set gvar(with_digits) 0

# weitere Variablen
set gvar(mode) 2
set gvar(mode_max) 2

#***********************************************************************
proc gui_init {} {
	global gvar
	wm title . "ScopeClock" 
	wm resizable . 0 0
	frame .f
	button .f.b_mode -text "Mode" -command switch_mode
	spinbox .f.zoom -from 1 -to 4 -textvariable gvar(zoom) -width 1 -command display_scope -state disabled
	spinbox .f.sdx -from 1 -to 10 -textvariable gvar(sdx) -width 2 -command display_scope -state disabled
	spinbox .f.sdy -from 1 -to 20 -textvariable gvar(sdy) -width 2 -command display_scope -state disabled
	checkbutton .f.with_digits -variable gvar(with_digits) -offvalue 0 -onvalue 1 -command display_scope -state disabled
	label .f.l_zoom -text " Zoom:"
	label .f.l_sdx -text " sdx:"
	label .f.l_sdy -text " sdy:"
	label .f.l_with_digits -text " Digits:"
	canvas	.clock -width $gvar(dx) -height $gvar(dy) -bg black -bd 0
	pack .clock .f 
	pack .f.b_mode .f.l_zoom .f.zoom .f.l_sdx .f.sdx\
		 .f.l_sdy .f.sdy .f.l_with_digits .f.with_digits -side left 
	.clock create oval	0 0 $gvar(dx) $gvar(dy)\
						-outline $gvar(color_off)\
						-fill $gvar(color_off)
}

#***********************************************************************
proc my_cos {val} {
	global val_cos
	if {$val<16} 				{set ret [lindex $val_cos $val]}
	if {($val>=16)&&($val<=29)} {set ret [expr -1 *[lindex $val_cos [expr 30 - $val]]]}
	if {($val>=30)&&($val<=45)} {set ret [expr -1 * [lindex $val_cos [expr $val-30]]]}
	if {($val>=46)&&($val<=59)} {set ret [lindex $val_cos [expr 60 - $val]]}
	return $ret
}

#***********************************************************************
proc my_sin {val} {
	global val_sin
	if {$val<16} 				{set ret [lindex $val_sin $val]}
	if {($val>=16)&&($val<=29)} {set ret [lindex $val_sin [expr 30 - $val]]}
	if {($val>=30)&&($val<=45)} {set ret [expr -1 * [lindex $val_sin [expr $val-30]]]}
	if {($val>=46)&&($val<=59)} {set ret [expr -1* [lindex $val_sin [expr 60 - $val]]]}
	return $ret
}

#***********************************************************************
proc fat_hand {val dist} {
	global gvar
	set ir [expr $gvar(count_x)/2 - 5]
	# 0 Grad	
	set y0 [expr $gvar(r) - ($gvar(r)-$dist) * [my_cos $val]/1000]
	set x0 [expr $gvar(r) + ($gvar(r)-$dist) * [my_sin $val]/1000]
	# 180 Grad
	set val [expr $val + 30]
	if {$val > 59} {set val [expr $val - 60]}
	set y2 [expr $gvar(r) - ($gvar(r)-$ir) * [my_cos $val]/1000]
	set x2 [expr $gvar(r) + ($gvar(r)-$ir) * [my_sin $val]/1000]
	# 90 Grad
	set val [expr $val + 15]
	if {$val > 59} {set val [expr $val - 60]}
	set y3 [expr $gvar(r) - ($gvar(r)-$ir) * [my_cos $val]/1000]
	set x3 [expr $gvar(r) + ($gvar(r)-$ir) * [my_sin $val]/1000]
	#180 Grad
	set val [expr $val + 30]
	if {$val > 59} {set val [expr $val - 60]}
	set y1 [expr $gvar(r) - ($gvar(r)-$ir) * [my_cos $val]/1000]
	set x1 [expr $gvar(r) + ($gvar(r)-$ir) * [my_sin $val]/1000]
	# ...und Zeiger zeichnen	
	plot_line $x0 $y0 $x1 $y1
	plot_line $x1 $y1 $x2 $y2
	plot_line $x2 $y2 $x3 $y3
	plot_line $x3 $y3 $x0 $y0
}


#***********************************************************************
proc display_scope {} {
	global gvar
	# Uhrzeit/Datum ermitteln
	set s [scan [clock format [clock seconds] -format %S] %d]
	set m [scan [clock format [clock seconds] -format %M] %d]
	set h [scan [clock format [clock seconds] -format %H] %d]
	set d [scan [clock format [clock seconds] -format %d] %d]
	set mo [scan [clock format [clock seconds] -format %m] %d]
	set yy [scan [clock format [clock seconds] -format %y] %d]
	clear_scope
	switch $gvar(mode) {
		0 {
			plot_circle 50 50 50
			plot_digit 10 30 0 2
			plot_digit 20 30 1 2
			plot_digit 30 30 2 2
			plot_digit 40 30 3 2
			plot_digit 50 30 4 2
			plot_digit 60 30 5 2
			plot_digit 70 30 6 2
			plot_digit 80 30 7 2
			plot_digit 10 60 8 2
			plot_digit 20 60 9 2
			plot_digit 30 60 10 2
			plot_digit 40 60 11 2
		}
		1 {
			# ...Digitalanzeige
			.f.zoom configure -state normal
			.f.sdx configure -state normal
			.f.sdy configure -state normal
			.f.with_digits configure -state disabled
			# Datum dd.mm.yy
			set y [expr $gvar(count_y)/2 - $gvar(sdy)/2 - $gvar(ddy)*$gvar(zoom)]
			set x [expr $gvar(count_x)/2 - (8 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx)))/2]
			plot_digit [expr $x + 0 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y [expr $d/10] $gvar(zoom)
			plot_digit [expr $x + 1 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y [expr $d%10] $gvar(zoom)
			plot_digit [expr $x + 2 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y 10 $gvar(zoom)
			plot_digit [expr $x + 3 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y [expr $mo/10] $gvar(zoom)
			plot_digit [expr $x + 4 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y [expr $mo%10] $gvar(zoom)
			plot_digit [expr $x + 5 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y 10 $gvar(zoom)
			plot_digit [expr $x + 6 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y [expr $yy/10] $gvar(zoom)
			plot_digit [expr $x + 7 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y [expr $yy%10] $gvar(zoom)
			# Uhrzeit hh:mm:ss
			set y [expr $gvar(count_y)/2 + $gvar(sdy)/2]
			set x [expr $gvar(count_x)/2 - (8 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx)))/2]
			plot_digit [expr $x + 0 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y [expr $h/10] $gvar(zoom)
			plot_digit [expr $x + 1 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y [expr $h%10] $gvar(zoom)
			plot_digit [expr $x + 2 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y 11 $gvar(zoom)
			plot_digit [expr $x + 3 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y [expr $m/10] $gvar(zoom)
			plot_digit [expr $x + 4 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y [expr $m%10] $gvar(zoom)
			plot_digit [expr $x + 5 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y 11 $gvar(zoom)
			plot_digit [expr $x + 6 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y [expr $s/10] $gvar(zoom)
			plot_digit [expr $x + 7 * ($gvar(ddx)*$gvar(zoom)+$gvar(sdx))] $y [expr $s%10] $gvar(zoom)
		}
		2 {
			# ...Analoganzeige
			.f.zoom configure -state disabled
			.f.sdx configure -state disabled
			.f.sdy configure -state disabled
			.f.with_digits configure -state normal
			# Ziffernblatt
			for {set i 0} {$i<60} {incr i 5} {
				set y0 [expr $gvar(r) - $gvar(r) * [my_cos $i]/1000]
				set x0 [expr $gvar(r) + $gvar(r) * [my_sin $i]/1000]
				set y1 [expr $gvar(r) - ($gvar(r)-2) * [my_cos $i]/1000]
				set x1 [expr $gvar(r) + ($gvar(r)-2) * [my_sin $i]/1000]
				plot_line $x0 $y0 $x1 $y1
				# mit Ziffern?
				if {$gvar(with_digits)} {
					set y [expr $gvar(r) - ($gvar(r)-10) * [my_cos $i]/1000]
					set x [expr $gvar(r) + ($gvar(r)-10) * [my_sin $i]/1000]
					set d [expr $i / 5]
					if {($d>0) && ($d<10)} {
						plot_digit [expr $x - $gvar(ddx)/2] [expr $y - $gvar(ddy)/2] $d 1
					} else {
						if {$d==0} {set d 12}
						plot_digit [expr $x - $gvar(ddx)-1] [expr $y - $gvar(ddy)/2] 1 1
						plot_digit [expr $x + $gvar(ddx)-1] [expr $y - $gvar(ddy)/2] [expr $d % 10] 1
					}
				}
			}
			for {set i 0} {$i<60} {incr i} {
				set y0 [expr $gvar(r) - $gvar(r) * [my_cos $i]/1000]
				set x0 [expr $gvar(r) + $gvar(r) * [my_sin $i]/1000]
				set y1 [expr $gvar(r) - $gvar(r) * [my_cos $i]/1000]
				set x1 [expr $gvar(r) + $gvar(r) * [my_sin $i]/1000]
				plot_line $x0 $y0 $x1 $y1
			}
			# Sekunden-Zeiger (einfacher Strich vom Mittelpunkt...)
			set y [expr $gvar(r) - ($gvar(r)-5) * [my_cos $s]/1000]
			set x [expr $gvar(r) + ($gvar(r)-5) * [my_sin $s]/1000]
			plot_line $gvar(r) $gvar(r) $x $y
			# Minuten-Zeiger
			fat_hand $m 10
			# Stunden-Zeiger
			if {$h > 11} {set h [expr $h - 12]}
			set h [expr $h * 5 + $m / 12]
			fat_hand $h 25
		}
		default {
			puts "ja was nun?"
		}
	}
}

#***********************************************************************
proc switch_mode {} {
		global gvar
		set gvar(mode) [incr gvar(mode)]
		if {$gvar(mode) > $gvar(mode_max)} {set gvar(mode) 1}
		display_scope
}

#***********************************************************************
proc plot_point {x y color} {
	global gvar
	.clock create oval	[expr (($gvar(dx) / $gvar(count_x)) * $x)]\
						[expr (($gvar(dy) / $gvar(count_y)) * $y)]\
						[expr (($gvar(dx) / $gvar(count_x)) * ($x + 1))]\
						[expr (($gvar(dy) / $gvar(count_y)) * ($y + 1))]\
						-outline $gvar(color_on)\
						-fill $gvar(color_on)\
						-tags [list scope pixel]
}

#***********************************************************************
proc clear_scope {} {
	.clock delete pixel
}

#***********************************************************************
proc sgn {a} {expr {$a>0 ? 1 : $a<0 ? -1 : 0}}

#***********************************************************************
# http://de.wikipedia.org/wiki/Bresenham-Algorithmus
#
proc plot_line {x0 y0 x1 y1} {
	global gvar
	set dx [expr $x1 - $x0]; set dy [expr $y1 - $y0]
	set adx [expr abs($dx)]; set ady [expr abs($dy)]
	set sdx [sgn $dx]; set sdy [sgn $dy]
	if {$adx > $ady} {
		set pdx $sdx; set pdy 0
		set ddx $sdx; set ddy $sdy
		set es $ady; set el $adx
	} else {
		set pdx 0; set pdy $sdy
		set ddx $sdx; set ddy $sdy
		set es $adx; set el $ady		
	}
	set x $x0; set y $y0
	plot_point $x $y $gvar(color_on)
	set err [expr $el / 2]
	for {set t 0} {$t < $el} {incr t} {
		set err [expr $err - $es]
		if {$err < 0} {
			set err [expr $err + $el]
			set x [expr $x + $ddx]
			set y [expr $y + $ddy]
		} else {
			set x [expr $x + $pdx]
			set y [expr $y + $pdy]			
		}
		plot_point $x $y $gvar(color_on)
	}
}

#***********************************************************************
# http://de.wikipedia.org/wiki/Bresenham-Algorithmus
#
proc plot_circle {x0 y0 r} {
	global gvar
	set f [expr 1 - $r]
	set ddf_x  0
	set ddf_y [expr -2 * $r]
	set x 0
	set y $r
	plot_point $x0 [expr $y0 + $r] $gvar(color_on)
	plot_point $x0 [expr $y0 - $r] $gvar(color_on)
	plot_point [expr $x0 + $r] $y0 $gvar(color_on)
	plot_point [expr $x0 - $r] $y0 $gvar(color_on)
	while {$x < $y} {
		if {$f >= 0} {
			set y [expr $y - 1]
			set ddf_y [expr $ddf_y + 2]
			set f [expr $f + $ddf_y]
		}
		set x [incr x]
		set ddf_x [expr $ddf_x + 2]
		set f [expr $f + ($ddf_x + 1)]
		plot_point [expr $x0 + $x] [expr $y0 + $y] $gvar(color_on)
		plot_point [expr $x0 - $x] [expr $y0 + $y] $gvar(color_on)
		plot_point [expr $x0 + $x] [expr $y0 - $y] $gvar(color_on)
		plot_point [expr $x0 - $x] [expr $y0 - $y] $gvar(color_on)
		plot_point [expr $x0 + $y] [expr $y0 + $x] $gvar(color_on)
		plot_point [expr $x0 - $y] [expr $y0 + $x] $gvar(color_on)
		plot_point [expr $x0 + $y] [expr $y0 - $x] $gvar(color_on)
		plot_point [expr $x0 - $y] [expr $y0 - $x] $gvar(color_on)
	}
}

#***********************************************************************
proc plot_digit {px py value zoom} {
	global digit
	set d [lindex $digit $value]
	foreach l $d {
		set first 1
		foreach {x y} $l {
			set x [expr $x * $zoom]
			set y [expr $y * $zoom]
			if {$first} {
				set x0 $x
				set y0 $y
				set first 0
			} else {
				plot_line 	[expr $x0 + $px] [expr $y0 + $py]\
							[expr $x + $px] [expr $y + $py]
				set x0 $x
				set y0 $y			
			}		
		}
	}	
} 

#***********************************************************************
proc tick {} {
	display_scope
	after 200 tick
}

#***********************************************************************
#***********************************************************************
#***********************************************************************
gui_init
tick

